function airseatDrawBoardingSchemes(boardingTypes, seatOrders)
    
    %% Load results data
    load airseatResults
    
    %% Draw images
    figure(1); clf
    for k = 1:length(boardingTypes)
        subplot(3,2,k);
        LocDrawCabin(boardingTypes{k}, seatOrders(k).weights);
    end
end

function LocDrawCabin(bType, weights)

    numRows = size(weights, 1);
    numSeats = size(weights, 2);
    
    weights = log(weights*10); weights = weights./max(weights(:));
    for k = 1:numRows
        for m = 1:(numSeats/2)
            [x,y] = LocCircPatch(k, m);
            xyCol = [0 weights(k, (numSeats/2)+m) 0];
            fill(x, y, xyCol);
            hold on
            xyCol = [0 weights(k, (numSeats/2)-m+1) 0];
            [x,y] = LocCircPatch(k, -m);
            fill(x, y, xyCol);
        end
        if rem(k, 5) == 0
            t = text(k, (numSeats/2)+1, sprintf('%d', k));
            set(t, 'horizontalAlignment','center')
            set(t, 'fontsize', 7);
            set(t, 'fontweight', 'bold');
            
            t = text(k, -((numSeats/2)+1), sprintf('%d', k));
            set(t, 'horizontalAlignment','center')
            set(t, 'fontsize', 7);
            set(t, 'fontweight', 'bold');
        end
    end
    cVal = 1;
    for k = -(numSeats/2):(numSeats/2)
        if k ~= 0
            t = text(0, k, sprintf('%s', char(64+cVal)));
            set(t, 'horizontalAlignment','center')
            set(t, 'fontsize', 7);
            set(t, 'fontweight', 'bold');
            cVal = cVal + 1;
        end
    end
    set(gca,'dataAspectRatio',[10 10 1]);
    set(gca, 'ytick', []);
    set(gca, 'xtick', []);
    set(gca, 'ylim', [-((numSeats/2)+2) ((numSeats/2)+2)])
    set(gca, 'xlim', [-1 numRows+2]);
    
    title(bType)
end

function [x,y] = LocCircPatch(k,m)
    r = 0.35;
    x = -(r+eps):0.01:(r+eps);
    y = sqrt(r^2 - x.^2);
    
    x(~isreal(y)) = [];
    y(~isreal(y)) = [];
    x = [-r x r];
    y = [0 y 0];
    
    x = [x fliplr(x)];
    y = [y -fliplr(y)];
    x = x + k;
    y = y + m;
end    
